﻿using MapControl;
using System.Collections.Generic;

namespace GWXDeliveryDemo
{
    public class RoutesVisualManager
    {
        readonly Map _mapControl;

        readonly Dictionary<int, RouteVisualInfo> _allRoutes = new Dictionary<int, RouteVisualInfo>();

        public RoutesVisualManager(Map mapControl)
        {
            _mapControl = mapControl;
        }

        public void AddSegment(int routeId, IEnumerable<Location> points, string text)
        {
            if (!_allRoutes.ContainsKey(routeId))
            {
                _allRoutes.Add(routeId, new RouteVisualInfo(_mapControl));
            }

            var routeInfo = _allRoutes[routeId];
            routeInfo.AddSegment(points, text);
        }

        public void AddStop(int routeId, Location point, string text, string shortText)
        {
            if (!_allRoutes.ContainsKey(routeId))
            {
                _allRoutes.Add(routeId, new RouteVisualInfo(_mapControl));
            }

            var routeInfo = _allRoutes[routeId];
            routeInfo.AddStop(point, text, shortText);
        }

        public void Clear()
        {
            foreach (var routeInfo in _allRoutes)
            {
                routeInfo.Value.Clear();
            }
        }
    }
}
